#!/bin/sh

# Duarte Loreto <happyguy_pt@hotmail.com>
# This is more open than GPL. So what you want with it. Just don't blame me if your car stops working

##########
# Variable declaration
##########
WORK_DIR=/home/dnloreto/FREECIV_CVS
CVS_COPY_DIR=/home/dnloreto/FREECIV_CVS/TESTE_S1_14/
PO_LANG=not_initialized
TRANS=0
FUZZY=0
UNTRANS=0
TEMP=0
TEMP_LANG=xxx
TOTAL_MSGID=0

##########
# Function declaration
##########
genMakefile() {
	cd $CVS_COPY_DIR
	./autogen.sh
}

createPoFiles() {
	cd $CVS_COPY_DIR/po/
	for i in `ls *.po`; 
	do 
		make "$i"x; 
	done;
}

createPoStatus() {
	cd $CVS_COPY_DIR/po/
	rm $WORK_DIR/PO_OUTPUT.temp
	
	for i in `ls *.pox`; 
	do 
		echo $i >> $WORK_DIR/PO_OUTPUT.temp
		msgfmt -cv $i 2>> $WORK_DIR/PO_OUTPUT.temp
	done;
	
	# Need dummy line to force generation of last language
	echo "dummy.pox" >> $WORK_DIR/PO_OUTPUT.temp
}

generateHTMLTable() {
	rm $WORK_DIR/statusBody.html
	TOTAL_MSGID=`msgfmt --statistics $CVS_COPY_DIR/po/freeciv.pot 2> TEMP_VAR; cat TEMP_VAR | awk -F " " '{print $4}'`
	generateHTMLHeader
	
	for i in `cat $WORK_DIR/PO_OUTPUT.temp`;
	do
		TEMP_LANG=`echo $i | awk -F "." '{print $2}'`
		
		if [ "$TEMP_LANG" == "pox" ]
		then
			if [ "$PO_LANG" == "not_initialized" ]
			then
				echo "Starting..."
			else
				buildBodyLine
				TRANS=0
				FUZZY=0
				UNTRANS=0
			fi;
			
			PO_LANG=`echo $i | awk -F "." '{print $1}'`
			getPOLang
		else
			if [ "$i" == "translated" ]
			then
				TRANS=$TEMP
			else
				if [ "$i" == "untranslated" ]
				then
					UNTRANS=$TEMP
				else
					if [ "$i" == "fuzzy" ]
					then
						FUZZY=$TEMP
					else
						TEMP=$i
					fi;
				fi;
			fi;
		fi;
	done;
	
	generateHTMLFooter
}

getPOLang() {
	case $PO_LANG in 
		da)
			PO_LANG="Danish ($PO_LANG)"
			;;
		de)
			PO_LANG="German ($PO_LANG)"
			;;
		en_GB)
			PO_LANG="British ($PO_LANG)"
			;;
		es)
			PO_LANG="Spanish ($PO_LANG)"
			;;
		et)
			PO_LANG="Estonian ($PO_LANG)"
			;;
		fi)
			PO_LANG="Finish ($PO_LANG)"
			;;
		fr)
			PO_LANG="French ($PO_LANG)"
			;;
		hu)
			PO_LANG="Hungary ($PO_LANG)"
			;;
		it)
			PO_LANG="Italian ($PO_LANG)"
			;;
		ja)
			PO_LANG="Japonese ($PO_LANG)"
			;;
		nl)
			PO_LANG="Dutch ($PO_LANG)"
			;;
		no)
			PO_LANG="Norwegian ($PO_LANG)"
			;;
		pl)
			PO_LANG="Polish ($PO_LANG)"
			;;
		pt)
			PO_LANG="Portuguese ($PO_LANG)"
			;;
		pt_BR)
			PO_LANG="Brazilian PT ($PO_LANG)"
			;;
		ro)
			PO_LANG="Romanian ($PO_LANG)"
			;;
		ru)
			PO_LANG="Russian ($PO_LANG)"
			;;
		sv)
			PO_LANG="Swedish ($PO_LANG)"
			;;
		*)
			PO_LANG="UNKNOWN ($PO_LANG)"
			;;
	esac	
}

buildBodyLine() {
	TRANS_100=`echo "$TRANS*100" | bc`
	FUZZY_100=`echo "$FUZZY*100" | bc`
	UNTRANS_100=`echo "$UNTRANS*100" | bc`
	TRANS_PER=`echo "$TRANS_100/$TOTAL_MSGID" | bc`
	FUZZY_PER=`echo "$FUZZY_100/$TOTAL_MSGID" | bc`
	UNTRANS_PER=`echo "$UNTRANS_100/$TOTAL_MSGID" | bc`
	
	echo "<tr><td>$PO_LANG</td>" >> $WORK_DIR/statusBody.html
	
	echo "<td>$TRANS</td><td>$TRANS_PER</td>" >> $WORK_DIR/statusBody.html
	echo "<td>$FUZZY</td><td>$FUZZY_PER</td>" >> $WORK_DIR/statusBody.html
	echo "<td>$UNTRANS</td><td>$UNTRANS_PER</td>" >> $WORK_DIR/statusBody.html
	
	echo "<td><img src=bar0.gif height=15 width=$TRANS_PER%><img src=bar4.gif height=15 width=$FUZZY_PER%><img src=bar1.gif height=15 width=$UNTRANS_PER%></td>" >> $WORK_DIR/statusBody.html
}

generateHTMLHeader() {
	echo "<html><body>" >> $WORK_DIR/statusBody.html
	echo "<table border=1 cellspacing=1 cellpadding=2 width=100%><tr>" >> $WORK_DIR/statusBody.html
	echo "<td width=20%>Language</td>" >> $WORK_DIR/statusBody.html
	echo "<td width=8%>Trans</td><td width=2%>%</td>" >> $WORK_DIR/statusBody.html
	echo "<td width=8%>Fuzzy</td><td width=2%>%</td>" >> $WORK_DIR/statusBody.html
	echo "<td width=8%>Untrans</td><td width=2%>%</td>" >> $WORK_DIR/statusBody.html
	echo "<td width=50%>Status Graphic</td></tr>" >> $WORK_DIR/statusBody.html
}

generateHTMLFooter() {
	echo "</table></body></html>" >> $WORK_DIR/statusBody.html
}

############
# Start working
############
genMakefile
createPoFiles
createPoStatus
generateHTMLTable
